#region Using

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Collections;
using System.Data.SqlClient;

using Wisej.Core;
using Wisej.Web;
using System.Diagnostics;


#endregion

namespace WisejTestApplication1
{
	public partial class FormDataGridViewTest:Form
	{
		public FormDataGridViewTest()
		{
			InitializeComponent();

		}

		private string Dump(object objectitem)
		{
			if(objectitem==null)
			{
				return("NULL");
			}
			return(objectitem.ToString());
		}

		private void FormDataGridViewTest_Load(object sender,EventArgs e)
		{
			AttachDataGridViewEvent=false;

			IsDataBinding=true;
			ctlComboboxAutosizerowmode.DataSource=Enum.GetValues(typeof(DataGridViewAutoSizeRowsMode));
			ctlComboboxAutosizecolumnmode.DataSource=Enum.GetValues(typeof(DataGridViewAutoSizeColumnsMode));
			IsDataBinding=false;

			ctlDatagridview1.RowEnter+=ctlDatagridview1_RowEnter;
			ctlDatagridview1.CellEnter+=ctlDatagridview1_CellEnter;
			ctlDatagridview1.CellValueChanged+=ctlDatagridview1_CellValueChanged;
			ctlDatagridview1.RowsAdded+=ctlDatagridview1_RowsAdded;
			ctlDatagridview1.UserAddedRow+=ctlDatagridview1_UserAddedRow;
			ctlDatagridview1.UserDeletedRow+=CtlDatagridview1_UserDeletedRow;
			ctlDatagridview1.CellClick+=CtlDatagridview1_CellClick;

			FillDataGridView(ctlDatagridview1,false);
		}

		private void CtlDatagridview1_CellClick(object sender,DataGridViewCellEventArgs e)
		{
			var oDatatable=((BindingSource)ctlDatagridview1.DataSource).DataSource as DataTable;
			if(oDatatable==null)
				return;
			if(oDatatable.Columns[e.ColumnIndex].ExtendedProperties.Contains("Button"))
			{
				MessageBox.Show("Button in Cell[" +
					e.ColumnIndex.ToString() + "," +
					e.RowIndex.ToString() + "] has been clicked");
			}
		}


		private bool IsDataBinding { get;set;}

		void ctlDatagridview1_CellValueChanged(object pv_oSender,DataGridViewCellEventArgs pv_oEventargs)
		{
			Debug.WriteLine("ctlDatagridview1_CellValueChanged"+Dump(pv_oEventargs.RowIndex)+Dump(pv_oEventargs.ColumnIndex));
			if(pv_oEventargs.RowIndex==ctlDatagridview1.NewRowIndex)
			{
				Debug.WriteLine("ctlDatagridview1_CellValueChanged:** Insert New Row"+Dump(pv_oEventargs.RowIndex));
			}
		}

		void ctlDatagridview1_CellEnter(object pv_oSender,DataGridViewCellEventArgs pv_oEventargs)
		{
			Debug.WriteLine("ctlDatagridview1_CellEnter"+Dump(pv_oEventargs.RowIndex));
		}

		void ctlDatagridview1_RowEnter(object pv_oSender,DataGridViewCellEventArgs pv_oEventargs)
		{
			Debug.WriteLine("ctlDatagridview1_RowEnter"+Dump(pv_oEventargs.RowIndex));
		}

		void ctlDatagridview1_RowsAdded(object pv_oSender,DataGridViewRowsAddedEventArgs pv_oEventargs)
		{
			if(pv_oEventargs.RowIndex<0)
			{
				return;
			}
			Debug.WriteLine("ctlDatagridview1_RowsAdded"+Dump(pv_oEventargs.RowIndex));
			Debug.WriteLine(Dump(pv_oEventargs.RowCount));

			DataGridView oDatagridview=(DataGridView)pv_oSender;
			DataGridViewRow oRow=oDatagridview.Rows[pv_oEventargs.RowIndex];
			IEnumerator oEnum=oRow.Cells.GetEnumerator();
			string strValue="";
			while(oEnum.MoveNext())
			{
				DataGridViewCell oCell=(DataGridViewCell)oEnum.Current;
				strValue+=Dump(oCell.Value);
			}
			
			Debug.WriteLine(Dump(strValue));
		}

		void ctlDatagridview1_UserAddedRow(object pv_oSender,DataGridViewRowEventArgs pv_oEventargs)
		{
			if(pv_oEventargs.Row==null)
			{
				return;
			}
			Debug.WriteLine("ctlDatagridview1_UserAddedRow"+Dump(pv_oEventargs.Row));
			Debug.WriteLine(Dump(pv_oEventargs.Row.Cells));

			IEnumerator oEnum=pv_oEventargs.Row.Cells.GetEnumerator();
			string strValue="";
			while(oEnum.MoveNext())
			{
				DataGridViewCell oCell=(DataGridViewCell)oEnum.Current;
				strValue+=Dump(oCell.FormattedValue);
			}
			Debug.WriteLine(Dump(strValue));
		}
		private void CtlDatagridview1_UserDeletedRow(object sender,DataGridViewRowEventArgs e)
		{
			//throw new NotImplementedException();
		}

		private bool AttachDataGridViewEvent {get;set;}

		private void InitDataGridView(DataGridView pv_oDatagridview)
		{
			if(!AttachDataGridViewEvent)
			{
				AttachDataGridViewEvent=true;
				ctlDatagridview1.DataError+=CtlDatagridview1_DataError;
				ctlDatagridview1.CellFormatting+=CtlDatagridview1_CellFormatting;
			}
			
			//ctlDatagridview1.SuspendLayout();
			ctlDatagridview1.ShowColumnVisibilityMenu=ctlCheckboxChooseColumn.Checked;
			ctlDatagridview1.ReadOnly=ctlCheckboxReadOnly.Checked;

			//WiseJDataGridViewBug#4: AutoSizeRowsMode and AutoSizeColumnsMode seems to be have no effect
			// Have this features any effect or is it be implemented in future 
			// Row size
			if(ctlComboboxAutosizerowmode.SelectedItem!=null)
			{
				DataGridViewAutoSizeRowsMode oRowmode=(DataGridViewAutoSizeRowsMode)ctlComboboxAutosizerowmode.SelectedItem;
				ctlDatagridview1.AutoSizeRowsMode=oRowmode;
			}
			// Column size
			if(ctlComboboxAutosizecolumnmode.SelectedItem!=null)
			{
				DataGridViewAutoSizeColumnsMode oColumnmode=(DataGridViewAutoSizeColumnsMode)ctlComboboxAutosizecolumnmode.SelectedItem;
				ctlDatagridview1.AutoSizeColumnsMode=oColumnmode;
			}

			ctlDatagridview1.AllowUserToAddRows=ctlCheckboxAddRow.Checked;
			ctlDatagridview1.AllowUserToDeleteRows=ctlCheckboxDeleteRow.Checked;

			//WiseJDataGridViewBug#3: Marker column move from front to lasts column (look at screenshot)
			//Bug occurs sometimes, I guess these 3 property have something to do with the effect
			ctlDatagridview1.AllowUserToOrderColumns=ctlCheckboxOrderColumn.Checked;
			ctlDatagridview1.AllowUserToResizeColumns=ctlCheckboxResizeCol.Checked;
			ctlDatagridview1.AllowUserToResizeRows=ctlCheckboxResizeRow.Checked;
		}

		private void FillDataGridView(DataGridView pv_oDatagridview,bool bOnlyschema)
		{
			if(ctlCheckboxInternTable.Checked)
			{
				InitDataGridView(ctlDatagridview1);
				int nCol=Convert.ToInt32(ctlTextboxCol.Text);
				int nRow=Convert.ToInt32(ctlTextboxRow.Text);
				BuildDataGridViewColumn(CreateDatatable(nCol,nRow,true));
				if(bOnlyschema)
				{
					return;
				}
				ctlDatagridview1.AutoGenerateColumns=false;
				FillDataGridViewDataFromIntern(ctlDatagridview1);
			}
			else
			{
				InitDataGridView(ctlDatagridview1);
				if(bOnlyschema)
				{
					return;
				}
				ctlDatagridview1.AutoGenerateColumns=true;
				FillDataGridViewDataFromConnection(ctlDatagridview1);
			}
		}

		private void CtlDatagridview1_CellFormatting(object sender,DataGridViewCellFormattingEventArgs e)
		{
			if(!ctlCheckBoxCellFormatEvent.Checked)
			{
				return;
			}
			if(e.ColumnIndex<0||e.RowIndex<0)
			{
				return;
			}
			// Set random background color
			var oCellstyle=e.CellStyle;
			oCellstyle.BackColor=GetRandomColor(0);
			oCellstyle.ForeColor=GetRandomColor(1);
			//e.FormattingApplied=true;
		}
		private Color GetRandomColor(int option)
		{
			int nRed=new Random(DateTime.Now.Second).Next(0,255);
			int nGreen=new Random(DateTime.Now.Millisecond).Next(0,255);
			int nBlue=new Random(DateTime.Now.Minute).Next(0,255);
			// Fix color
			if(option==0)
			{
				if(DateTime.Now.Second<60&&DateTime.Now.Second>50) nBlue=255;
				if(DateTime.Now.Second<50&&DateTime.Now.Second>30) nGreen=255;
				if(DateTime.Now.Second<30&&DateTime.Now.Second>10) nRed=255;
			}
			if(option==1)
			{
				if(DateTime.Now.Second<60&&DateTime.Now.Second>50) nRed=255;
				if(DateTime.Now.Second<50&&DateTime.Now.Second>30) nBlue=255;
				if(DateTime.Now.Second<30&&DateTime.Now.Second>10) nGreen=255;
			}

			return(System.Drawing.Color.FromArgb(nRed,nGreen,nBlue));
		}
		private void CtlDatagridview1_DataError(object sender,DataGridViewDataErrorEventArgs e)
		{
			int a=0;a++;
		}

		// ==========================================================================================================================================



		private DataSet m_oDataset=new DataSet();
		private string m_strCurrentconnectionstring { get;set;}
		private SqlDataAdapter CurrentSqlAdapter { get;set;}
		private void ctlButtonConnect_Click(object sender,EventArgs e)
		{
			ctlButtonConnect.Text="Connecting ...";

			string strConnectionstring;
			string strCommand;
			string strUser;
			GetDataBaseFieldInfo(out strConnectionstring,out strCommand,out strUser);

			try
			{
				m_strCurrentconnectionstring=strConnectionstring;
				SqlConnection oConnection=new SqlConnection(strConnectionstring);
				oConnection.Open();
				CurrentSqlAdapter=new SqlDataAdapter(strCommand,oConnection);
				ctlButtonConnect.Text="Connected !";
			}
			catch(Exception ex)
			{
				MessageBox.Show("ctlButtonConnect_Click:"+ex.Message);
				ctlButtonConnect.Text="Connect";
			}
		}
		
		private void ctlButtonFill_Click(object sender,EventArgs e)
		{
			FillDataGridView(ctlDatagridview1,false);
		}

		private void FillDataGridViewDataFromIntern(DataGridView pv_oDatagridview)
		{
			try
			{
				int nCol=Convert.ToInt32(ctlTextboxCol.Text);
				int nRow=Convert.ToInt32(ctlTextboxRow.Text);

				DataTable oDatatable=CreateDatatable(nCol,nRow,false);

				//pv_oDatagridview.DataSource=oDatatable;
				BindingSource oBindingsource=new BindingSource();
				oBindingsource.DataSource=oDatatable;
				pv_oDatagridview.DataSource=oBindingsource;
			}
			catch(Exception ex)
			{
				MessageBox.Show("FillDataGridViewDataFromIntern:"+ex.Message);
			}
		}	

		Button oButton=null;
        private DataTable CreateDatatable(int intCols, int intRows,bool bOnlyschema)
        {
            DataTable oDatatable=new DataTable();
            for (int i=0;i<intCols;i++)
            {
				DataColumn oColumn=new DataColumn();
				oColumn.ColumnName="Col"+i.ToString();
				switch(i)
				{
					case 0:
					{
						oColumn.DataType=typeof(string);
						oColumn.Caption="String";
					}
					break;
					case 1:
					{
						oColumn.DataType=typeof(DateTime);
						oColumn.Caption="DateTime";
					}
					break;
					case 2:
					{
						oColumn.DataType=typeof(bool);
						oColumn.Caption="bool";
					}
					break;
					case 3:
					{
						oColumn.DataType=typeof(int);
						oColumn.Caption="int";
					}
					break;
					case 4:
					{
						oColumn.DataType=typeof(double);
						oColumn.Caption="double";
					}
					break;
					case 6:
					{
						oColumn.DataType=typeof(string);
						oColumn.Caption="List<string>";

						List<KeyValuePair<string,string>> oList=new List<KeyValuePair<string, string>>();
						oList.Add(new KeyValuePair<string, string>("ListKey0","List"+(i).ToString()));
						oList.Add(new KeyValuePair<string, string>("ListKey1","List"+(i+1).ToString()));
						oList.Add(new KeyValuePair<string, string>("ListKey2","List"+(i+1).ToString()));
						oList.Add(new KeyValuePair<string, string>("ListKey3","List"+(i+5).ToString()));
						oList.Add(new KeyValuePair<string, string>("ListKey4","List"+(i+21).ToString()));

						oColumn.ExtendedProperties.Add("List",oList);
					}
					break;
					case 7:
					{
						oColumn.DataType=typeof(string);
						oColumn.Caption="Button";

						oButton=new Button();
						oButton.Click+=new EventHandler(
						delegate(object pv_oSender,EventArgs pv_oEventargument) 
						{
							MessageBox.Show("Pressed the Button");
						}
						);
						oColumn.ExtendedProperties.Add("Button",oButton);
					}
					break;
					default:
					{
						oColumn.DataType=typeof(string);
						oColumn.Caption="String";
					}
					break;
				}

                oDatatable.Columns.Add(oColumn);
            }

			if(bOnlyschema)
			{
				return(oDatatable);
			}

            for (int i=0;i<intRows;i++)
            {
                DataRow oDatarow=oDatatable.NewRow();
                for (int j=0;j<intCols;j++)
                {
					string strColumnname="Col"+j.ToString();

					if(oDatatable.Columns[strColumnname].DataType==typeof(string))
					{
						bool bBound=false;
						if(oDatatable.Columns[strColumnname].ExtendedProperties.Contains("List"))
						{
							bBound=true;
							oDatarow[strColumnname]="ListKey0";
							if((i%2)==0)
							{
								oDatarow[strColumnname]="ListKey3";
							}
						}
						if(!bBound)
						{
							if(oDatatable.Columns[strColumnname].ExtendedProperties.Contains("Button"))
							{
								bBound=true;
								oDatarow[strColumnname]="Button1";
								if((i%2)==0)
								{
									oDatarow[strColumnname]="Button"+i.ToString();
								}
							}
						}
						if(!bBound)
						{
							if((i%2)==0)
							{
								oDatarow[strColumnname]=Guid.NewGuid().ToString();
							}
							else
							{
								oDatarow[strColumnname]="Text"+j.ToString();;
							}
						}
					}
					if(oDatatable.Columns[strColumnname].DataType==typeof(int))
					{
						if((i%2)==0)
						{
							oDatarow[strColumnname]=(j*5)+i;
						}
						else
						{
							oDatarow[strColumnname]=i;
						}
					}
					if(oDatatable.Columns[strColumnname].DataType==typeof(double))
					{
						if((i%2)==0)
						{
							oDatarow[strColumnname]=new Random(DateTime.Now.Second).NextDouble();
						}
						else
						{
							oDatarow[strColumnname]=(double)j/i;
						}
					}
					if(oDatatable.Columns[strColumnname].DataType==typeof(DateTime))
					{
						if((i%2)==0)
						{
							oDatarow[strColumnname]=DateTime.Now;
						}
						else
						{
							oDatarow[strColumnname]=new DateTime(2012,12,12);
						}
					}
                }
                oDatatable.Rows.Add(oDatarow);
            }
            return oDatatable;
        }

        private void BuildDataGridViewColumn(DataTable pv_oDatatable)
        {
			List<int> oFreezecolumnlist=new List<int>(1);
			if(ctlTextboxFreezeColumn.Text.Length>0)
			{
				if(ctlTextboxFreezeColumn.Text.Contains(";"))
				{
					string[] oStringlist=ctlTextboxFreezeColumn.Text.Split(';');
					oFreezecolumnlist=oStringlist.Select(x=>int.Parse(x)).ToList<int>();
				}
				else
				{
					oFreezecolumnlist.Add(Convert.ToInt32(ctlTextboxFreezeColumn.Text)); 
				}
			}

			ctlDatagridview1.Columns.Clear();
            for (int i=0;i<pv_oDatatable.Columns.Count;i++)
            {
				DataGridViewColumn oDatagridviewcolumn=null;
				string strColumnname=pv_oDatatable.Columns[i].ColumnName;
				DataColumn oColumn=pv_oDatatable.Columns[i];
				switch(System.Type.GetTypeCode(oColumn.DataType))
				{
					case TypeCode.Boolean:
					{
						oDatagridviewcolumn=new DataGridViewCheckBoxColumn();
						((DataGridViewCheckBoxColumn)oDatagridviewcolumn).CellTemplate=new DataGridViewCheckBoxCell();
					}
					break;
					case TypeCode.String:
					{
						bool bBound=false;
						if(!bBound)
						{
							if(oColumn.ExtendedProperties.Contains("List"))
							{
								bBound=true;
								oDatagridviewcolumn=new DataGridViewComboBoxColumn();
								((DataGridViewComboBoxColumn)oDatagridviewcolumn).CellTemplate=new DataGridViewComboBoxCell();
								((DataGridViewComboBoxColumn)oDatagridviewcolumn).DropDownStyle=ComboBoxStyle.DropDownList;
								var oList=pv_oDatatable.Columns[i].ExtendedProperties["List"] as List<KeyValuePair<string,string>>;

								((DataGridViewComboBoxColumn)oDatagridviewcolumn).DataSource=oList;
								((DataGridViewComboBoxColumn)oDatagridviewcolumn).ValueMember="Key";
								((DataGridViewComboBoxColumn)oDatagridviewcolumn).DisplayMember="Value";
							}
						}
						if(!bBound)
						{
							if(oColumn.ExtendedProperties.Contains("Button"))
							{
								bBound=true;
								oDatagridviewcolumn=new DataGridViewButtonColumn();
								((DataGridViewButtonColumn)oDatagridviewcolumn).CellTemplate=new DataGridViewButtonCell();
							}
						}
						if(!bBound)
						{
							// Default is text column
							oDatagridviewcolumn=new DataGridViewTextBoxColumn();
							((DataGridViewTextBoxColumn)oDatagridviewcolumn).CellTemplate=new DataGridViewTextBoxCell();
						}

					}
					break;
					case TypeCode.Int32:
					{
						//WiseJDataGridViewBug#5: DataGridView DataGridViewNumericUpDownColumn set old value to 0
						//if i.e. the value of the int is 5 and you doubleclick the column for edit mode: The value will be set to 0.
						//Is there a detail option to hold the value of 5? 
						oDatagridviewcolumn=new DataGridViewNumericUpDownColumn();
						((DataGridViewNumericUpDownColumn)oDatagridviewcolumn).CellTemplate=new DataGridViewNumericUpDownCell();
					}
					break;
					case TypeCode.Double:
					{
						oDatagridviewcolumn=new DataGridViewMaskedTextBoxColumn();
						((DataGridViewMaskedTextBoxColumn)oDatagridviewcolumn).CellTemplate=new DataGridViewMaskedTextBoxCell();
						((DataGridViewMaskedTextBoxColumn)oDatagridviewcolumn).PromptChar='_';
						((DataGridViewMaskedTextBoxColumn)oDatagridviewcolumn).Mask="00.0000";
					}
					break;
					case TypeCode.DateTime:
					{
						oDatagridviewcolumn=new DataGridViewDateTimePickerColumn();
						((DataGridViewDateTimePickerColumn)oDatagridviewcolumn).CellTemplate=new DataGridViewDateTimePickerCell();
						oDatagridviewcolumn.DefaultCellStyle.Format="d";
					}
					break;
					default:
					{
						oDatagridviewcolumn=new DataGridViewTextBoxColumn();
						((DataGridViewTextBoxColumn)oDatagridviewcolumn).CellTemplate=new DataGridViewTextBoxCell();
					}
					break;
				}

				if(ctlCheckboxSort.Checked)
				{
					oDatagridviewcolumn.SortMode=DataGridViewColumnSortMode.Automatic;
				}
				else
				{
					oDatagridviewcolumn.SortMode=DataGridViewColumnSortMode.NotSortable;
				}

				oDatagridviewcolumn.HeaderText=oColumn.Caption;
				oDatagridviewcolumn.DataPropertyName=strColumnname;

				// Freeze please
				if(oFreezecolumnlist.Contains(i))
				{
					//WiseJDataGridViewBug#2: Freeze column Index 0+3 causes 3 Columns to be frozwn
					oDatagridviewcolumn.Frozen=true;
				}

				// Set style
				oDatagridviewcolumn.HeaderCell.Style.Alignment=DataGridViewContentAlignment.MiddleLeft;
				
				//WiseJDataGridViewBug#1: Activate this codeline to suppress all CellFormat layout to table
				//oDatagridviewcolumn.DefaultCellStyle.Alignment=DataGridViewContentAlignment.MiddleLeft;

				ctlDatagridview1.Columns.Add(oDatagridviewcolumn);
			}
		}

		private void FillDataGridViewDataFromConnection(DataGridView pv_oDatagridview)
		{
			try
			{
				if(CurrentSqlAdapter==null)
				{
					ctlButtonConnect_Click(null,null);
				}
				string strConnectionstring;
				string strCommand;
				string strUser;
				GetDataBaseFieldInfo(out strConnectionstring,out strCommand,out strUser);
				if(CurrentSqlAdapter!=null&&strConnectionstring!=null)
				{
					m_oDataset=new DataSet();
					CurrentSqlAdapter.SelectCommand.CommandText=strCommand;
					CurrentSqlAdapter.Fill(m_oDataset);
		
					BindingSource oBindingsource=new BindingSource();
					oBindingsource.DataSource=m_oDataset.Tables[0];
					pv_oDatagridview.DataSource=oBindingsource;
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show("FillDataGridViewDataFromConnection:"+ex.Message);
			}			
		}			

		private void GetDataBaseFieldInfo(out string pv_strConnectionstring,out string pv_strCommand,out string pv_strUser)
		{
			pv_strUser=ctlTextboxUser.Text;
			pv_strConnectionstring="Data Source="+ctlTextboxServer.Text+";Initial Catalog="+ctlTextboxDatabase.Text+";Persist Security Info=True;User ID="+pv_strUser+";Password="+ctlTextboxPassword.Text;
			pv_strCommand="Select * from "+ctlTextboxTable.Text;
		}

		private void ctlCheckboxInternTable_CheckedChanged(object sender,EventArgs e)
		{
			if(ctlCheckboxInternTable.Checked)
			{
				ctlGroupboxConnection.Enabled=false;
			}
			else
			{
				ctlGroupboxConnection.Enabled=true;
			}
		}

		private void ctlButtonApply_Click(object sender,EventArgs e)
		{
			FillDataGridView(ctlDatagridview1,true);
			ctlDatagridview1.Refresh();
		}

	}
}